#!/bin/bash

# FIXME: This is a hack to make sure the environment is activated.
# The reason this is required is due to the conda-build issue
# mentioned below.
#
# https://github.com/conda/conda-build/issues/910
#
if [ "$(uname)" == "Darwin" ]
then
    export LIBRARY_SEARCH_VAR=DYLD_FALLBACK_LIBRARY_PATH
    function ver {
        printf "%03d%03d%03d%03d" $(echo "$1" | tr '.' ' ')
    }

    function ver_2back {
        major=$(echo "$1" | cut -d. -f1)
        minor=$(echo "$1" | cut -d. -f2)
        minor=$(expr ${minor} - 2)
        echo $(ver ${major}.${minor})
    }

    MACOS_SDK=`xcrun --show-sdk-version`
    EXTRAS="-DCMAKE_OSX_DEPLOYMENT_TARGET=10.7 -DCMAKE_OSX_SYSROOT=macosx10.12"
    # Typically you can build macOS - 2, e.g 10.12 can build against 10.10 SDK
    if [ $(ver ${MACOS_SDK}) -gt $(ver '10.9') ] && \
        [ $(ver ${MACOSX_DEPLOYMENT_TARGET}) -lt $(ver_2back ${MACOS_SDK}) ]
    then
        # This deployment target is not supported
        echo "ERROR! ${MACOSX_DEPLOYMENT_TARGET} target not possible on ${MACOS_SDK}"
        #exit 3
    fi
    if [ $(ver ${MACOS_SDK}) -ge $(ver ${MACOSX_DEPLOYMENT_TARGET}) ]; then
        # Download the appropriate macOS sdk
        #curl -L -o macOS_${MACOSX_DEPLOYMENT_TARGET}.tar.xz \
        #    https://github.com/phracker/MacOSX-SDKs/releases/download/MacOSX10.11.sdk/MacOSX${MACOSX_DEPLOYMENT_TARGET}.sdk.tar.xz
        #tar zxf macOS_${MACOSX_DEPLOYMENT_TARGET}.tar.xz
        #EXTRAS="-DCMAKE_OSX_SYSROOT=`pwd`/MacOSX${MACOSX_DEPLOYMENT_TARGET}.sdk"
        echo Poop
    fi
else
    export LIBRARY_SEARCH_VAR=LD_LIBRARY_PATH
    EXTRAS=''
fi

mkdir build
cd build
cmake ..\
        -Wno-dev \
        -DCMAKE_INSTALL_PREFIX="${PREFIX}" \
        -DCMAKE_INSTALL_LIBDIR="${PREFIX}/lib" \
        -DCMAKE_PREFIX_PATH="${PREFIX}" \
        -DCMAKE_C_FLAGS="${CFLAGS}" \
        -DCMAKE_CXX_FLAGS="${CXXFLAGS}" \
        -DBUILD_STATIC_LIBS=1 \
        -DBUILD_SHARED_LIBS=1 \
        -DCMAKE_SHARED_LINKER_FLAGS="${LDFLAGS}" \
        -DCMAKE_EXE_LINKER_FLAGS="${LDFLAGS}" \
        -DPYTHON_EXECUTABLE="${PYTHON}" \
        ${EXTRAS}

make
eval ${LIBRARY_SEARCH_VAR}=$PREFIX/lib make jsoncpp_check
make install
